#version 330

in vec2 fragTex;

uniform sampler2D colorTexture;
uniform float lumThresh = 0.97;

out vec4 fragColor;

float luma(vec3 color)
{
	return 0.2126 * color.r + 0.7152 * color.g + 0.0722 * color.b;
}

void main()
{
	vec3 color3 = texture(colorTexture, fragTex).rgb;
	vec4 color4=vec4(color3,1.0);

	fragColor= color4 * clamp(luma(color4.rgb) - lumThresh, 0.0, 1.0) * (1.0 / (1.0 - lumThresh));

}
