#version 330

in vec2 fragTex;

uniform sampler2D colorTexture;
uniform int height;

//uniform float gaussPixelOffsets[10] = float[](0.0, 2.0, 4.0, 6.0, 8.0, 10.0, 12.0, 14.0, 16.0, 18.0);
//uniform float gaussWeight[10] = float[](0.88, 0.66, 0.44, 0.22508352, 0.11098164, 0.05472157, 0.02736, 0.00655965, 0.00019117, 0.00002292/*, 0.00000067, 0.0, 0.0*/);
//uniform float gaussWeight[10] = float[](1.0, 0.5, 0.25, 0.125, 0.0625, 0.03125, 0.015625, 0.0078125, 0.0, 0.0);
//uniform float gaussWeight[10] = float[](0.8, 0.4, 0.2, 0.1, 0.05, 0.025, 0.0125, 0.00625, 0.0, 0.0);
//uniform float gaussWeight[10] = float[](0.99, 0.88, 0.77, 0.66, 0.55, 0.44, 0.33,0.33, 0.22, 0.22);
//uniform float gaussPixelOffsets[20] = float[](0.0, 1.0, 2.0, 3.0, 4.0, 5.0, 6.0, 7.0, 8.0, 9.0, 10.0, 11.0, 12.0, 13.0, 14.0, 15.0, 16.0, 17.0, 18.0, 19.0);
//uniform float gaussWeight[20] = float[](0.88, 0.44, 0.22508352, 0.11098164, 0.05472157, 0.027, 0.0135, 0.00655965, 0.00328, 0.00164, 0.00082, 0.00041, 0.00019117, 0.00009506, 0.00004753, 0.00002292, 0.00001146, 0.000005073, 0.000002536, 0.0000018);
//uniform float gaussPixelOffsets[10] = float[](0.0, 2.0, 4.0, 6.0, 8.0, 10.0, 12.0, 14.0, 16.0, 18.0);
//uniform float gaussWeight[10] = float[](0.22508352, 0.11098164, 0.05472157, 0.00655965, 0.00019117, 0.00002292, 0.00000067, 0.0, 0.0, 0.0);
uniform float gaussPixelOffsets[11] = float[](0.0, 1.0, 2.0, 3.0, 4.0, 5.0, 6.0, 7.0, 8.0, 9.0, 10.0);
//uniform float gaussWeight[10] = float[](48620.0/262144.0, 43758.0/262144.0, 31824.0/262144.0, 18564.0/262144.0, 8568.0/262144.0,  3060.0/262144.0,   816.0/262144.0,   153.0/262144.0,   18.0/262144.0,     1.0/262144.0);
//weil Pascal-Dreieck fr 10 Binomialkoeffizienten: 1    18    153   816  3060  8568  18564 31824 43758 48620 43758 31824 18564 8568  3060   816   153   18     1, jeweils dividiert durch Summe 262144 (2^n)

//uniform float gaussWeight[6] = float[](0.24802,	0.20448,0.11458,0.04364,0.01130,0.00199);
uniform float gaussWeight[11] = float[](0.1330, 0.1258, 0.1065,0.0807,0.0547,0.0332,0.0180,0.0087,0.0038,0.0015,0.0005);



out vec4 fragColor;

void main()
{
	float dy=1.0/float(height);
	vec4 sum = texture(colorTexture, fragTex)*gaussWeight[0];
	vec2 ff;
	for(int i=1;i<11;i++)	
	{
		//Texturkoordinaten von 0 bis 1 -> nicht "ber den Rand bloomen", sonst leuchtet es auf der anderen Seite auch
		//Blur der MipMaps addieren, um greres Filterkernel zu simulieren
		if((fragTex.y + gaussPixelOffsets[i]*dy)<1.0)
		{
			sum+=textureLod(colorTexture, fragTex + vec2(0.0, gaussPixelOffsets[i])*dy, 0.0) * gaussWeight[i];
			//sum+=textureLod(colorTexture, fragTex + vec2(0.0, gaussPixelOffsets[i])*dy, 1.0) * gaussWeight[i];
			/*sum+=(textureLod(colorTexture, fragTex + vec2(0.0, gaussPixelOffsets[i])*dy, 2.0) * gaussWeight[i])/6;
			sum+=(textureLod(colorTexture, fragTex + vec2(0.0, gaussPixelOffsets[i])*dy, 3.0) * gaussWeight[i])/6;
			sum+=(textureLod(colorTexture, fragTex + vec2(0.0, gaussPixelOffsets[i])*dy, 4.0) * gaussWeight[i])/6;
			sum+=(textureLod(colorTexture, fragTex + vec2(0.0, gaussPixelOffsets[i])*dy, 5.0) * gaussWeight[i])/6;
			sum+=(textureLod(colorTexture, fragTex + vec2(0.0, gaussPixelOffsets[i])*dy, 6.0) * gaussWeight[i])/6;*/
			//if(fragTex.y +  gaussPixelOffsets[i]*dy < 1.0/128.0)
				//sum+=(textureLod(colorTexture, fragTex + vec2(0.0, gaussPixelOffsets[i])*dy, 7.0) * gaussWeight[i])/1;
		}
		if((fragTex.y - gaussPixelOffsets[i]*dy)>0.0)
		{
			sum+=textureLod(colorTexture, fragTex - vec2(0.0, gaussPixelOffsets[i])*dy, 0.0) * gaussWeight[i];
			//sum+=textureLod(colorTexture, fragTex - vec2(0.0, gaussPixelOffsets[i])*dy, 1.0) * gaussWeight[i];
			/*sum+=(textureLod(colorTexture, fragTex - vec2(0.0, gaussPixelOffsets[i])*dy, 2.0) * gaussWeight[i])/6;
			sum+=(textureLod(colorTexture, fragTex - vec2(0.0, gaussPixelOffsets[i])*dy, 3.0) * gaussWeight[i])/6;
			sum+=(textureLod(colorTexture, fragTex - vec2(0.0, gaussPixelOffsets[i])*dy, 4.0) * gaussWeight[i])/6;
			sum+=(textureLod(colorTexture, fragTex - vec2(0.0, gaussPixelOffsets[i])*dy, 5.0) * gaussWeight[i])/6;
			sum+=(textureLod(colorTexture, fragTex - vec2(0.0, gaussPixelOffsets[i])*dy, 6.0) * gaussWeight[i])/6*/;
			//if(fragTex.y +  gaussPixelOffsets[i]*dy > 0 + 1.0/128.0)
				//sum+=(textureLod(colorTexture, fragTex - vec2(0.0, gaussPixelOffsets[i])*dy, 7.0) * gaussWeight[i])/1;
		}
	}
	fragColor=sum;
}

