#version 330

in vec2 fragTex;

uniform sampler2D colorTexture;

uniform int fps;
uniform int fpsNK;
uniform int objectsRendered;

uniform float numberSize=0.03;
uniform float room = 0.01;
uniform float begin = 0.05;
uniform float dicke=0.005;
uniform vec4 fontColor=vec4(0,0,255,0.85);

out vec4 fragColor;

vec4 genKomma(in vec2 fragTex, in float startPos, in float yU, in float yO)
{
	if(fragTex.y>=yU && fragTex.y<yU+dicke*2 && fragTex.x>=startPos+numberSize/2-dicke && fragTex.x<startPos+numberSize/2+dicke)
			return fontColor;
	return vec4(0,0,0,0);
}

vec4 genNumber(in vec2 fragTex, in float n, in float startPos, in float yU, in float yO)
{
	float ySize=yO-yU;

	if(n==0)
	{
		if(
			(fragTex.y>=yU && fragTex.y<yU+dicke) ||		//unterer Rand
			(fragTex.y>=yO-dicke && fragTex.y<yO) ||		//oberer Rand
			(fragTex.x>=startPos && fragTex.x<startPos+dicke) ||	//linker Rand
			(fragTex.x>=startPos+numberSize-dicke && fragTex.x<startPos+numberSize))	//rechter Rand
				return fontColor;
	}
	if(n==1)
	{
		if(
			(fragTex.x>=startPos+numberSize-dicke && fragTex.x<startPos+numberSize))	//rechter Rand
				return fontColor;
	}
	if(n==2)
	{
		if(
			(fragTex.y>=yU && fragTex.y<yU+dicke) ||		//unterer Rand
			(fragTex.y>=yO-dicke && fragTex.y<yO) ||		//oberer Rand
			(fragTex.y>=yU+ySize/2-dicke/2 && fragTex.y<yO-ySize/2+dicke/2) ||	//Mittelstrich waagrecht
			(fragTex.x>=startPos && fragTex.x<startPos+dicke && fragTex.y>=yU && fragTex.y<yU+ySize/2) ||	//linker Rand unten
			(fragTex.x>=startPos+numberSize-dicke && fragTex.x<startPos+numberSize && fragTex.y>=yO-ySize/2 && fragTex.y<yO))	//rechter Rand oben
				return fontColor;
	}
	if(n==3)
	{
		if(
			(fragTex.y>=yU && fragTex.y<yU+dicke) ||		//unterer Rand
			(fragTex.y>=yO-dicke && fragTex.y<yO) ||		//oberer Rand
			(fragTex.y>=yU+ySize/2-dicke/2 && fragTex.y<yO-ySize/2+dicke/2) ||	//Mittelstrich waagrecht
			(fragTex.x>=startPos+numberSize-dicke && fragTex.x<startPos+numberSize))	//rechter Rand
				return fontColor;
	}
	if(n==4)
	{
		if(
			(fragTex.y>=yU+ySize/2-dicke/2 && fragTex.y<yO-ySize/2+dicke/2) ||	//Mittelstrich waagrecht
			(fragTex.x>=startPos+numberSize-dicke && fragTex.x<startPos+numberSize) ||	//rechter Rand
			(fragTex.x>=startPos && fragTex.x<startPos+dicke && fragTex.y>=yO-ySize/2 && fragTex.y<yO))	//linker Rand oben
				return fontColor;
	}
	if(n==5)
	{
		if(
			(fragTex.y>=yU && fragTex.y<yU+dicke) ||		//unterer Rand
			(fragTex.y>=yO-dicke && fragTex.y<yO) ||		//oberer Rand
			(fragTex.y>=yU+ySize/2-dicke/2 && fragTex.y<yO-ySize/2+dicke/2) ||	//Mittelstrich waagrecht
			(fragTex.x>=startPos+numberSize-dicke && fragTex.x<startPos+numberSize && fragTex.y>=yU && fragTex.y<yU+ySize/2) ||	//rechter Rand unten
			(fragTex.x>=startPos && fragTex.x<startPos+dicke && fragTex.y>=yO-ySize/2 && fragTex.y<yO))	//linker Rand oben
				return fontColor;
	}
	if(n==6)
	{
		if(
			(fragTex.y>=yO-dicke && fragTex.y<yO) ||		//oberer Rand
			(fragTex.y>=yU && fragTex.y<yU+dicke) ||		//unterer Rand
			(fragTex.y>=yU+ySize/2-dicke/2 && fragTex.y<yO-ySize/2+dicke/2) ||	//Mittelstrich waagrecht
			(fragTex.x>=startPos+numberSize-dicke && fragTex.x<startPos+numberSize && fragTex.y>=yU && fragTex.y<yU+ySize/2) ||	//rechter Rand unten
			(fragTex.x>=startPos && fragTex.x<startPos+dicke))	//linker Rand
				return fontColor;
	}
	if(n==7)
	{
		if(
			(fragTex.x>=startPos+numberSize-dicke && fragTex.x<startPos+numberSize) ||	//rechter Rand
			(fragTex.y>=yO-dicke && fragTex.y<yO))		//oberer Rand
				return fontColor;
	}
	if(n==8)
	{
		if(
			(fragTex.y>=yU && fragTex.y<yU+dicke) ||		//unterer Rand
			(fragTex.y>=yO-dicke && fragTex.y<yO) ||		//oberer Rand
			(fragTex.y>=yU+ySize/2-dicke/2 && fragTex.y<yO-ySize/2+dicke/2) ||	//Mittelstrich waagrecht
			(fragTex.x>=startPos && fragTex.x<startPos+dicke) ||	//linker Rand
			(fragTex.x>=startPos+numberSize-dicke && fragTex.x<startPos+numberSize))	//rechter Rand
				return fontColor;
	}
	if(n==9)
	{
		if(
			(fragTex.y>=yU && fragTex.y<yU+dicke) ||		//unterer Rand
			(fragTex.y>=yO-dicke && fragTex.y<yO) ||		//oberer Rand
			(fragTex.y>=yU+ySize/2-dicke/2 && fragTex.y<yO-ySize/2+dicke/2) ||	//Mittelstrich waagrecht
			(fragTex.x>=startPos && fragTex.x<startPos+dicke && fragTex.y>=yO-ySize/2 && fragTex.y<yO) ||	//linker Rand oben
			(fragTex.x>=startPos+numberSize-dicke && fragTex.x<startPos+numberSize))	//rechter Rand
				return fontColor;
	}
	return vec4(0,0,0,0);
}

vec4 genF(in vec2 fragTex, in float startPos, in float yU, in float yO)
{
	float ySize=yO-yU;

	if(
		(fragTex.y>=yO-dicke && fragTex.y<yO) ||		//oberer Rand
		(fragTex.y>=yU+ySize/2-dicke/2 && fragTex.y<yO-ySize/2+dicke/2) ||	//Mittelstrich waagrecht
		(fragTex.x>=startPos && fragTex.x<startPos+dicke))	//linker Rand
			return fontColor;
	return vec4(0,0,0,0);
}

vec4 genP(in vec2 fragTex, in float startPos, in float yU, in float yO)
{
	float ySize=yO-yU;

	if(
		(fragTex.y>=yO-dicke && fragTex.y<yO) ||		//oberer Rand
		(fragTex.y>=yU+ySize/2-dicke/2 && fragTex.y<yO-ySize/2+dicke/2) ||	//Mittelstrich waagrecht
		(fragTex.x>=startPos && fragTex.x<startPos+dicke) ||	//linker Rand
		(fragTex.x>=startPos+numberSize-dicke && fragTex.x<startPos+numberSize && fragTex.y>=yO-ySize/2 && fragTex.y<yO))	//rechter Rand oben
			return fontColor;
	return vec4(0,0,0,0);
}

vec4 genS(in vec2 fragTex, in float startPos, in float yU, in float yO)
{
	return genNumber(fragTex, 5, startPos, yU, yO);	//S ist wie 5
}

vec4 genJ(in vec2 fragTex, in float startPos, in float yU, in float yO)
{
	float ySize=yO-yU;

	if(
		(fragTex.y>=yU && fragTex.y<yU+dicke) ||		//unterer Rand
		(fragTex.x>=startPos && fragTex.x<startPos+dicke && fragTex.y>=yU && fragTex.y<yU+ySize/2) ||	//linker Rand unten
		(fragTex.x>=startPos+numberSize-dicke && fragTex.x<startPos+numberSize))	//rechter Rand
			return fontColor;
	return vec4(0,0,0,0);
}

vec4 genFPSText(in vec2 fragTex) 
{
	  float n;
	  float yU=0.9;
	  float yO=0.93;

	  if(fragTex.y>=yU && fragTex.y<yO)
	  {
		  if(fragTex.x>=begin && fragTex.x<begin+numberSize)	//Hunderter-Stelle
		  {
			  n=(mod(fps, 1000) - mod(fps, 100))/100;
			  float startPos=begin;
			  if(n>0)		//allererste fhrende Null vermeiden
				return genNumber(fragTex, n, startPos, yU, yO);
		   }
		  if(fragTex.x>= begin+numberSize+room && fragTex.x<begin+numberSize*2+room)	//Zehner-Stelle
		  {
			  n=(mod(fps, 100) - mod(fps, 10))/10;
			  float startPos=begin+numberSize+room;
			  return genNumber(fragTex, n, startPos, yU, yO);
		   }
		  if(fragTex.x>= begin+numberSize*2+room*2 && fragTex.x<begin+numberSize*3+room*2)	//Einer-Stelle
		  {
			  n=mod(fps, 10);
			  float startPos=begin+numberSize*2+room*2;
			  return genNumber(fragTex, n, startPos, yU, yO);
		   }

		  if(fragTex.x>= begin+numberSize*3+room*3 && fragTex.x<begin+numberSize*4+room*3)	//Komma
		  {
		    float startPos=begin+numberSize*3+room*3;
			return genKomma(fragTex, startPos, yU, yO);
		  }

		if(fragTex.x>=begin+numberSize*4+room*4 && fragTex.x<begin+numberSize*5+room*4)	//Zehntel-Stelle
		  {
			  n=(mod(fpsNK, 1000) - mod(fpsNK, 100))/100;
			  float startPos=begin+numberSize*4+room*4;
			  if(n>0)		//allererste fhrende Null vermeiden
				return genNumber(fragTex, n, startPos, yU, yO);
		   }
		  if(fragTex.x>= begin+numberSize*5+room*5 && fragTex.x<begin+numberSize*6+room*5)	//Hundertstel-Stelle
		  {
			  n=(mod(fpsNK, 100) - mod(fpsNK, 10))/10;
			  float startPos=begin+numberSize*5+room*5;
			  return genNumber(fragTex, n, startPos, yU, yO);
		   }
		  if(fragTex.x>= begin+numberSize*6+room*6 && fragTex.x<begin+numberSize*7+room*6)	//Tausendstel-Stelle
		  {
			  n=mod(fpsNK, 10);
			  float startPos=begin+numberSize*6+room*6;
			  return genNumber(fragTex, n, startPos, yU, yO);
		   }
		  if(fragTex.x>= begin+numberSize*7+room*9 && fragTex.x<begin+numberSize*8+room*9)	//F
		  {
		    float startPos=begin+numberSize*7+room*9;
			return genF(fragTex, startPos, yU, yO);
		  }
		  if(fragTex.x>= begin+numberSize*8+room*10 && fragTex.x<begin+numberSize*9+room*10)	//P
		  {
		    float startPos=begin+numberSize*8+room*10;
			return genP(fragTex, startPos, yU, yO);
		  }
		  if(fragTex.x>= begin+numberSize*9+room*11 && fragTex.x<begin+numberSize*10+room*11)	//S
		  {
		    float startPos=begin+numberSize*9+room*11;
			return genS(fragTex, startPos, yU, yO);
		  }
		}
	return vec4(0,0,0,0);
}

vec4 genObjectsText(in vec2 fragTex) 
{
	  float n;
	  float yU=0.86;
	  float yO=0.89;

	  if(fragTex.y>=yU && fragTex.y<yO)
	  {
		 if(fragTex.x>=begin+numberSize*4+room*4 && fragTex.x<begin+numberSize*5+room*4)	//Zehntel-Stelle
		  {
			  n=(mod(objectsRendered, 1000) - mod(objectsRendered, 100))/100;
			  float startPos=begin+numberSize*4+room*4;
			  if(n>0)		//allererste fhrende Null vermeiden
				return genNumber(fragTex, n, startPos, yU, yO);
		   }
		  if(fragTex.x>= begin+numberSize*5+room*5 && fragTex.x<begin+numberSize*6+room*5)	//Zehner-Stelle
		  {
			  n=(mod(objectsRendered, 100) - mod(objectsRendered, 10))/10;
			  float startPos=begin+numberSize*5+room*5;
			  return genNumber(fragTex, n, startPos, yU, yO);
		   }
		  if(fragTex.x>= begin+numberSize*6+room*6 && fragTex.x<begin+numberSize*7+room*6)	//Einer-Stelle
		  {
			  n=mod(objectsRendered, 10);
			  float startPos=begin+numberSize*6+room*6;
			  return genNumber(fragTex, n, startPos, yU, yO);
		   }

		 
		  if(fragTex.x>= begin+numberSize*7+room*9 && fragTex.x<begin+numberSize*8+room*9)	//O
		  {
		    float startPos=begin+numberSize*7+room*9;
			return genNumber(fragTex, 0, startPos, yU, yO);	//O = 0
		  }
		  if(fragTex.x>= begin+numberSize*8+room*10 && fragTex.x<begin+numberSize*9+room*10)	//B
		  {
		    float startPos=begin+numberSize*8+room*10;
			return genNumber(fragTex, 8, startPos, yU, yO);	//B = 8
		  }
		  if(fragTex.x>= begin+numberSize*9+room*11 && fragTex.x<begin+numberSize*10+room*11)	//J
		  {
		    float startPos=begin+numberSize*9+room*11;
			return genJ(fragTex, startPos, yU, yO);
		  }
		}
	return vec4(0,0,0,0);
}

void main()
{	
	vec4 tmpFragColor=texture(colorTexture, fragTex);

	tmpFragColor+=genFPSText(fragTex);
	tmpFragColor+=genObjectsText(fragTex);
	
	fragColor=tmpFragColor;
}