#version 330

in vec2 fragTex;

uniform sampler2D colorTexture;
uniform int width;
uniform int height;

// Control exposure with this value	-> now per auto-exposure
//uniform float exposure = 30000;
// Max bright
uniform float brightMax = 65535;

out vec4 fragColor;

void main()
{
	
	vec4 tempFragColor=texture(colorTexture, fragTex);

	//Mipmap-sizes bei 800x600
	/*
	0:	800		x	600
	1:	400		x	300
	2:	200		x	150
	3:	100		x	 75
	4:	 50		x	 37
	5:	 25		x	 18
	6:	 12		x	  9
	7:	  6		x	  4
	8:	  3		x	  2
	9:	  1		x	  1
	*/

	//Lv. 7 schaut ganz gut aus.		
	/*int divisor= 128;	//2^7
	int reducedLevelWidth = width/divisor;
	int reducedLevelHeight = height/divisor;

	//laufe durch alle diese pixel und berechne mittlere helligkeit
	vec3 akkHell= vec3(0,0,0);
	for(int x=0; x<reducedLevelWidth; x++)	
	{
		for(int y=0; y<reducedLevelHeight; y++)
		{
			akkHell+=textureLod(colorTexture, vec2(x,y), 7.0).rgb;
		}
	}

	vec3 meanHell = akkHell/reducedLevelWidth/reducedLevelHeight;*/
	vec3 meanHell=textureLod(colorTexture, vec2(0,0), 10.0).rgb;

	// For HDR - Perform tone-mapping Version 4
	float luminance = (meanHell.r * 0.3) + (meanHell.g * 0.59) + (meanHell.b * 0.11);
	float key= 0.16;
	
	//float exposure = min(key/luminance, maxExposure);
	float exposure=key/luminance;
	//float exposure = 0.18/luminance;

	//10 steps:
	/*float stepsize=exposure/10;
	float step1=stepsize;
	float step2=stepsize*2;
	float step3=stepsize*3;
	float step4=stepsize*4;
	float step5=stepsize*5;
	float step6=stepsize*6;
	float step7=stepsize*7;
	float step8=stepsize*8;
	float step9=stepsize*9;
	float step10=stepsize*10;

	if(exposure<step1)	exposure=step1;
	if(exposure>step1)	exposure=step2;
	if(exposure>step2)	exposure=step3;
	if(exposure>step3)	exposure=step4;
	if(exposure>step4)	exposure=step5;
	if(exposure>step5)	exposure=step6;
	if(exposure>step6)	exposure=step7;
	if(exposure>step7)	exposure=step8;
	if(exposure>step8)	exposure=step9;
	if(exposure>step9)	exposure=step10;*/
	//tempFragColor *= 0.52/iLuminance;
	float maxBrightnessAdded=2.0;
	float tempFragColorBrightness = (tempFragColor.r * 0.3) + (tempFragColor.g * 0.59) + (tempFragColor.b * 0.11);
	tempFragColor *= pow(2, exposure);

	// For HDR - Perform tone-mapping Version 3
	/*vec4 tempFragColor=sum*bloomPower + originColor;
	float exposureCoeff = 0.59 * meanHell.r + 0.30 * meanHell.g + 0.11 * meanHell.b;		//0.30 * hell.r + 0.59 * hell.g + 0.11 * hell.b;
	
	float exposure;*/
	/*if(exposureCoeff >= 150/256*65535)
		exposure=3000;
	if(exposureCoeff < 150/256*65535 && exposureCoeff >=105/256*65535)
		exposure=8000;
	if(exposureCoeff < 105/256*65535 && exposureCoeff >=90/256*65535)
		exposure=15000;
	if(exposureCoeff < 90/256*65535 && exposureCoeff >=65/256*65535)
		exposure=20000;
	if(exposureCoeff < 65/256*65535)
		exposure=25500;*/
	//exposure = -pow(50, round(exposureCoeff/1000)*1000);		//auf ganze Tausender runden
	/*exposure = -pow(100, exposureCoeff);
	float YD = exposure * (exposure/brightMax + 1.0) / (exposure + 1.0);
	if(YD<0.1)
		YD=0.1;
	YD*=10;
	YD=round(YD)/10;
	//float YD = log(exposureCoeff+1)/log(brightMax+1);
	tempFragColor *= YD;
	*/
	// For HDR - Perform tone-mapping Version 1
	//float Y = dot(vec4(0.30, 0.59, 0.11, 0.0), originColor);
	//float YD = exposure * (exposure/brightMax + 1.0) / (exposure + 1.0);
	//originColor *= YD;
	/*
	vec4 tempFragColor=sum*bloomPower + originColor;

	//For HDR - get auto-exposure because of mean brightness of scene = smallest MipMap
	vec4 hell=textureLod(originalTexture, vec2(0,0), 10.0);
	float exposureCoeff = 0.30 * hell.r + 0.59 * hell.g + 0.11 * hell.b;

	float exposure = -pow(100, exposureCoeff);
	//float exposure = exposureCoeff/(1+exposureCoeff);

	// For HDR - Perform tone-mapping Version 2
	float Y = dot(vec4(0.30, 0.59, 0.11, 0.0), tempFragColor);
	float YD = exposure * (exposure/brightMax + 1.0) / (exposure + 1.0);
	//float YD = log(exposure+1)/log(brightMax+1);
	tempFragColor *= YD;*/

	fragColor = tempFragColor;

	//fragColor = textureLod(originalTexture, vec2(0,0), 10.0);
	//fragColor=originColor;
	//fragColor=sum;
}