#version 330


//in vec4 eye;
//in vec3 l_dir;

noperspective in vec2 fragTex;

uniform sampler2D colorTexture;

uniform sampler2D lensColorTexture;

//gute einstellungen, schmal und sternfrmig
/*uniform int uGhosts = 4; // number of ghost samples
uniform float uGhostDispersal = 0.02; // dispersion factor */

//gute einstellungen, schmal und sternfrmig und krftiger
uniform int uGhosts = 40; // number of ghost samples
uniform float uGhostDispersal = 0.02; // dispersion factor 


//commit: "schaut jz recht vernuenftig aus" + "woah O_o"
/*uniform int uGhosts = 4; // number of ghost samples
uniform float uGhostDispersal = 1; // dispersion factor*/

//commit: "etwas eingegrenzt"           --> auch ziemlich ok, hnlich wie "gute einstellungen"
/*uniform int uGhosts = 4; // number of ghost samples
uniform float uGhostDispersal = 0.25; // dispersion factor*/

//commit: "nicht mehr ganz so schoen"           --> strker, aber wirkt nicht mehr so diagonal
/*uniform int uGhosts = 6; // number of ghost samples
uniform float uGhostDispersal = 1.0; // dispersion factor*/

uniform float uHaloWidth = -5;		//damits sternfrmig ist, ist schner als der halo-ring
uniform float uDistortion = 7.5;

out vec4 fragColor;

//distort color channels        
                                                                                                                        // direction of distortion              // per-channel distortion factor
vec3 textureDistorted(in sampler2D tex, in vec2 texcoord, in vec2 direction,  in vec3 distortion) 
{
      return vec3(
         texture(tex, texcoord + direction * distortion.r).r,
         texture(tex, texcoord + direction * distortion.g).g,
         texture(tex, texcoord + direction * distortion.b).b
      );
}

void main() 
{
        if(fragTex.s>-0.5)      // auf 0.5 setzen -> debugger :P
                //if(dot(eye.rgb, l_dir)>0.0)     //nur rendern, wenn lichtquelle sichtbar	--> jz im Main.cpp mit Winkelberechnung
                {
                        //fragColor=max(vec4(0.0), texture(colorTexture, fragTex));
                        vec2 texcoord = -fragTex + vec2(1.0);   //spiegeln
                        vec2 texelSize = 1.0 / vec2(textureSize(colorTexture, 0));                                                      //for color distortion
                        vec3 distortion = vec3(-texelSize.x * uDistortion, 0.0, texelSize.x * uDistortion);     //for color distortion
 
                        // ghost vector to image centre:
                        vec2 ghostVec = (vec2(0.5) - texcoord) * uGhostDispersal;
                        vec2 direction = normalize(ghostVec);           //for color distortion
   
                        // sample ghosts:  
                        vec4 result = vec4(0.0);
                        for (int i = 0; i < uGhosts; ++i) { 
                                vec2 offset = fract(texcoord + ghostVec * float(i));
  
                                float weight = length(vec2(0.5) - offset) / length(vec2(0.5));          //urspr. 0.5
                                weight = pow(1.0 - weight, 10.0);
  
                                result.rgb += textureDistorted(colorTexture, offset, direction, distortion) * weight;
                                //result += texture(colorTexture, offset)*weight;
                        }
                        //Das Ex-1D-Zeug
                        //result *= texture(lensColorTexture, vec2(length(vec2(0.5)-texcoord), length(vec2(0.5)-texcoord)) / length(vec2(0.5)));
        
                        // sample halo:
                        vec2 haloVec = normalize(ghostVec) * uHaloWidth;
                        float weight = length(vec2(0.5) - fract(texcoord + haloVec)) / length(vec2(0.5));
                        weight = pow(1.0 - weight, 10.0);
                        result.rgb *= textureDistorted(lensColorTexture, texcoord + haloVec, direction, distortion) * weight;
                        //result *= texture(lensColorTexture, texcoord + haloVec) * weight;

                        fragColor = result;
                        }
                //else
                //fragColor=texture(colorTexture, fragTex);
        else
        fragColor=max(vec4(0.0), texture(colorTexture, fragTex));
        
        //fragColor=texture(lensColorTexture, vec2(0,0));
}