#version 330

//Initial velocity and start time
layout (location=0) in vec3 vertexInitVel;
layout (location=1) in float startTime;
/*layout (location=2) in float xv;
layout (location=3) in float yv;
layout (location=4) in float zv;*/

out float transp;	//transparency of particle

uniform mat4 projectionMatrix;
uniform mat4 viewMatrix;
uniform float time; //animation time, momentane zeit der applikation in sek.
uniform float particleLifetime;		//max particle lifetime in sek.
uniform vec3 startPosition;

uniform vec3 gravity = vec3(0.0, -9.8f, 0.0);	//world coords

void main()
{
	vec3 pos=vec3(0,0,0);
	transp=0.0;

	//Particle doesn't exist until the start time
	if(time>startTime)
	{
		float t=time-startTime;
		if(t<particleLifetime)
		{
			pos=startPosition+(vertexInitVel * t + gravity * t * t)*1.0;
			//pos=vec3(-9.0, 9.0, -9.0);
			transp = 1.0 - t/particleLifetime;

			/*//if(vertexInitVel.x <=0)// || vertexInitVel.y != 9 || vertexInitVel.x != -9)
				//transp=1.0;
			pos=vec3(-9.0, 9.0, -9.0);
			transp=1.0;

			ok=0.0;
			if(startTime == 9999 && vertexInitVel.x==-9.0 && vertexInitVel.y==9.0 && vertexInitVel.z==-9.0)// && vertexInitVel.y < -0.5 && vertexInitVel.x < -0.5)
			{				//vertexInitVel.x liegt zwischen -0.0025 und -0.00125
							//startTime liegt zwischen -0.00125 und -0.000125 - DOCH NICHT, es ist komplett random ...
				ok=1.0;
				okx=0.0;
				oky=0.0;
				okz=0.0;
			}
			else
			{
				ok=0.0;
				okx=vertexInitVel.x;
				oky=vertexInitVel.y;
				okz=vertexInitVel.z;
			}*/
		}
	}
	

	gl_Position = projectionMatrix  * viewMatrix * vec4(pos, 1.0);
}