#version 330
//uniform mat4 MVP;
 // Notice that the "1" here equals the "1" in glVertexAttribPointer
// Input vertex data, different for all executions of this shader.
layout(location = 0) in vec3 vertexPosition_modelspace;
layout(location = 1) in vec2 uvPosition;
layout(location = 2) in vec3 normal;
// Output data ; will be interpolated for each fragment.
out vec2 UV;
uniform mat4 modelMatrix;
uniform mat4 charModel;
uniform mat4 projectionMatrix;
uniform mat4 viewMatrix;
uniform vec3 lightDir;
uniform vec4 ambient;
uniform mat4 MS;
uniform mat4 MT;
uniform mat4 PLight;
uniform mat4 PView1;
uniform mat4 PView2;
uniform mat4 PView3;
uniform mat4 PView4;
uniform mat4 PView5;
uniform mat4 tex_mat1;
uniform mat4 tex_mat2;
uniform mat4 tex_mat3;
uniform mat4 tex_mat4;
uniform mat4 tex_mat5;
uniform vec3 charPos;
uniform int showCascades;
out vec4 SM_tex_coord1;
out vec4 SM_tex_coord2;
out vec4 SM_tex_coord3;
out vec4 SM_tex_coord4;
out vec4 SM_tex_coord5;
out vec3 n;
out vec4 eye;
out vec3 l_dir;
out vec4 amb;
out vec4 worldPos;
out vec4 worldCharPos;
flat out int showCascadesFrag;
void main(){
 
   
    vec4 v = vec4(vertexPosition_modelspace,1); // Transform an homogeneous 4D vector, remember ?
    gl_Position =   projectionMatrix  * viewMatrix * modelMatrix * vec4(vertexPosition_modelspace, 1);
    // UV of the vertex. No special space for this one.
    UV = uvPosition;
	worldPos =  modelMatrix * vec4(vertexPosition_modelspace, 1);
	worldCharPos = charModel * vec4(charPos, 1);
	mat4 m_normal = transpose(inverse(viewMatrix * modelMatrix));
	n = normalize(mat3(m_normal) * normal);
	eye = -(viewMatrix * modelMatrix * vec4(vertexPosition_modelspace,1.0));
	l_dir = mat3(viewMatrix) * lightDir;
	amb = ambient;
	SM_tex_coord1 = tex_mat1 * modelMatrix * vec4(vertexPosition_modelspace,1.0);
	SM_tex_coord2 = tex_mat2 * modelMatrix * vec4(vertexPosition_modelspace,1.0);
	SM_tex_coord3 = tex_mat3 * modelMatrix * vec4(vertexPosition_modelspace,1.0);
	SM_tex_coord4 = tex_mat4 * modelMatrix * vec4(vertexPosition_modelspace,1.0);
	SM_tex_coord5 = tex_mat5 * modelMatrix * vec4(vertexPosition_modelspace,1.0);
	showCascadesFrag = showCascades;
}