#version 330
//uniform mat4 MVP;
 // Notice that the "1" here equals the "1" in glVertexAttribPointer
// Input vertex data, different for all executions of this shader.
layout(location = 0) in vec3 vertexPosition_modelspace;
layout(location = 1) in vec2 uvPosition;
layout(location = 2) in vec3 normal;
// Output data ; will be interpolated for each fragment.
out vec2 UV;
uniform mat4 modelMatrix;
uniform mat4 projectionMatrix;
uniform mat4 viewMatrix;
uniform vec3 lightDir;
uniform vec4 ambient;
out vec3 n;
out vec4 eye;
out vec3 l_dir;
out vec4 amb;
void main(){
 
   
    vec4 v = vec4(vertexPosition_modelspace,1); // Transform an homogeneous 4D vector, remember ?
    gl_Position =   projectionMatrix  * viewMatrix * modelMatrix * vec4(vertexPosition_modelspace, 1);
    // UV of the vertex. No special space for this one.
    UV = uvPosition;

	mat4 m_normal = transpose(inverse(viewMatrix * modelMatrix));
	n = normalize(mat3(m_normal) * normal);
	eye = -(viewMatrix * modelMatrix * vec4(vertexPosition_modelspace,1.0));
	l_dir = mat3(viewMatrix) * lightDir;
	amb = ambient;
	
}