#version 330

in vec2 UV;
in vec3 n;
in vec4 eye;
in vec3 l_dir;
in vec4 amb;
out vec4 fragColor;
in vec4 SM_tex_coord1;
in vec4 SM_tex_coord2;
in vec4 SM_tex_coord3;
in vec4 SM_tex_coord4;
in vec4 SM_tex_coord5;
in vec4 worldPos;
in vec4 worldCharPos;
flat in int showCascadesFrag;
uniform sampler2D colorTexture;
uniform sampler2D shadowMap1;
uniform sampler2D shadowMap2;
uniform sampler2D shadowMap3;
uniform sampler2D shadowMap4;
uniform sampler2D shadowMap5;


void main()
{
	float pcf = 0.0;
	bool red = false;
	bool green = false;
	bool blue = false;
	bool yellow = false;
	bool magenta = false;
	bool inShadow = false;
	// perform perspective division 
	 vec3 tex_coords1 = SM_tex_coord1.xyz/SM_tex_coord1.w; 
	 // read depth value from shadow map 
	 float depth1 = texture(shadowMap1, tex_coords1.xy).r; 
	 // perform depth comparison 
	
	 // darken fragment color if in shadow... 

	 vec3 tex_coords2 = SM_tex_coord2.xyz/SM_tex_coord2.w; 
	 float depth2 = texture(shadowMap2, tex_coords2.xy).r; 

	 vec3 tex_coords3 = SM_tex_coord3.xyz/SM_tex_coord3.w; 
	 float depth3 = texture(shadowMap3, tex_coords3.xy).r; 

	 vec3 tex_coords4 = SM_tex_coord4.xyz/SM_tex_coord4.w; 
	 float depth4 = texture(shadowMap4, tex_coords4.xy).r;

	 vec3 tex_coords5 = SM_tex_coord5.xyz/SM_tex_coord5.w; 
	 float depth5 = texture(shadowMap5, tex_coords5.xy).r;

	 //	fragColor = vec4(depth,depth,depth,1.0);
		//return;

	//if(worldPos.x > worldCharPos.x - 20 && worldPos.x < worldCharPos.x + 20 && 
	//worldPos.z > worldCharPos.z - 20 && worldPos.z < worldCharPos.z + 20)
	if(tex_coords1.x >= 0.0 && tex_coords1.x <= 1.0 &&
	tex_coords1.y >= 0.0 && tex_coords1.y <= 1.0)
	{
		red = true;	
		  inShadow = (depth1 < tex_coords1.z) ? true : false;	
		float sum = 0.0;
		float val1 = textureProjOffset(shadowMap1,vec4(tex_coords1,1.0),ivec2(-1,-1)).r;
		float val2 = textureProjOffset(shadowMap1,vec4(tex_coords1,1.0),ivec2(-1,1)).r;
		float val3 = textureProjOffset(shadowMap1,vec4(tex_coords1,1.0),ivec2(1,-1)).r;
		float val4 = textureProjOffset(shadowMap1,vec4(tex_coords1,1.0),ivec2(1,1)).r;
		float val5 = textureProjOffset(shadowMap1,vec4(tex_coords1,1.0),ivec2(0,-1)).r;
		float val6 = textureProjOffset(shadowMap1,vec4(tex_coords1,1.0),ivec2(0,1)).r;
		float val7 = textureProjOffset(shadowMap1,vec4(tex_coords1,1.0),ivec2(-1,0)).r;
		float val8 = textureProjOffset(shadowMap1,vec4(tex_coords1,1.0),ivec2(1,0)).r;
		float val9 = textureProjOffset(shadowMap1,vec4(tex_coords1,1.0),ivec2(0,0)).r;
		bool b1 = (val1 < tex_coords1.z - 0.00005) ? true : false;
		bool b2 = (val2 < tex_coords1.z - 0.00005) ? true : false;
		bool b3 = (val3 < tex_coords1.z - 0.00005) ? true : false;
		bool b4 = (val4 < tex_coords1.z - 0.00005) ? true : false;
		bool b5 = (val5 < tex_coords1.z - 0.00005) ? true : false;
		bool b6 = (val6 < tex_coords1.z - 0.00005) ? true : false;
		bool b7 = (val7 < tex_coords1.z - 0.00005) ? true : false;
		bool b8 = (val8 < tex_coords1.z - 0.00005) ? true : false;
		bool b9 = (val9 < tex_coords1.z - 0.00005) ? true : false;

		pcf = (val1 + val2 + val3 + val4 + val5 + val6 + val7 + val8 + val9)/9;
		pcf = (b1 || b2 || b3 || b4 || b5 || b6 || b7 || b8 || b9) ? pcf : 1.0;

	}
	else if(tex_coords2.x >= 0.0 && tex_coords2.x <= 1.0 &&
	tex_coords2.y >= 0.0 && tex_coords2.y <= 1.0)
	{
		green = true;
	    inShadow = (depth2 < tex_coords2.z) ? true : false; 
		float sum = 0.0;
		float val1 = textureProjOffset(shadowMap2,vec4(tex_coords2,1.0),ivec2(-1,-1)).r;
		float val2 = textureProjOffset(shadowMap2,vec4(tex_coords2,1.0),ivec2(-1,1)).r;
		float val3 = textureProjOffset(shadowMap2,vec4(tex_coords2,1.0),ivec2(1,-1)).r;
		float val4 = textureProjOffset(shadowMap2,vec4(tex_coords2,1.0),ivec2(1,1)).r;
		float val5 = textureProjOffset(shadowMap2,vec4(tex_coords2,1.0),ivec2(0,-1)).r;
		float val6 = textureProjOffset(shadowMap2,vec4(tex_coords2,1.0),ivec2(0,1)).r;
		float val7 = textureProjOffset(shadowMap2,vec4(tex_coords2,1.0),ivec2(-1,0)).r;
		float val8 = textureProjOffset(shadowMap2,vec4(tex_coords2,1.0),ivec2(1,0)).r;
		float val9 = textureProjOffset(shadowMap2,vec4(tex_coords2,1.0),ivec2(0,0)).r;
		bool b1 = (val1 < tex_coords2.z - 0.00005) ? true : false;
		bool b2 = (val2 < tex_coords2.z - 0.00005) ? true : false;
		bool b3 = (val3 < tex_coords2.z - 0.00005) ? true : false;
		bool b4 = (val4 < tex_coords2.z - 0.00005) ? true : false;
		bool b5 = (val5 < tex_coords2.z - 0.00005) ? true : false;
		bool b6 = (val6 < tex_coords2.z - 0.00005) ? true : false;
		bool b7 = (val7 < tex_coords2.z - 0.00005) ? true : false;
		bool b8 = (val8 < tex_coords2.z - 0.00005) ? true : false;
		bool b9 = (val9 < tex_coords2.z - 0.00005) ? true : false;
		pcf = (val1 + val2 + val3 + val4 + val5 + val6 + val7 + val8 + val9)/9;
		pcf = (b1 || b2 || b3 || b4 || b5 || b6 || b7 || b8 || b9) ? pcf : 1.0;
	}
	else if(tex_coords3.x >= 0.0 && tex_coords3.x <= 1.0 &&
	tex_coords3.y >= 0.0 && tex_coords3.y <= 1.0)
	{
		blue = true;
	    inShadow = (depth3 < tex_coords3.z) ? true : false;		 
		float sum = 0.0;
		float val1 = textureProjOffset(shadowMap3,vec4(tex_coords3,1.0),ivec2(-1,-1)).r;
		float val2 = textureProjOffset(shadowMap3,vec4(tex_coords3,1.0),ivec2(-1,1)).r;
		float val3 = textureProjOffset(shadowMap3,vec4(tex_coords3,1.0),ivec2(1,-1)).r;
		float val4 = textureProjOffset(shadowMap3,vec4(tex_coords3,1.0),ivec2(1,1)).r;
		float val5 = textureProjOffset(shadowMap3,vec4(tex_coords3,1.0),ivec2(0,-1)).r;
		float val6 = textureProjOffset(shadowMap3,vec4(tex_coords3,1.0),ivec2(0,1)).r;
		float val7 = textureProjOffset(shadowMap3,vec4(tex_coords3,1.0),ivec2(-1,0)).r;
		float val8 = textureProjOffset(shadowMap3,vec4(tex_coords3,1.0),ivec2(1,0)).r;
		float val9 = textureProjOffset(shadowMap3,vec4(tex_coords3,1.0),ivec2(0,0)).r;
		bool b1 = (val1 < tex_coords3.z - 0.00005) ? true : false;
		bool b2 = (val2 < tex_coords3.z - 0.00005) ? true : false;
		bool b3 = (val3 < tex_coords3.z - 0.00005) ? true : false;
		bool b4 = (val4 < tex_coords3.z - 0.00005) ? true : false;
		bool b5 = (val5 < tex_coords3.z - 0.00005) ? true : false;
		bool b6 = (val6 < tex_coords3.z - 0.00005) ? true : false;
		bool b7 = (val7 < tex_coords3.z - 0.00005) ? true : false;
		bool b8 = (val8 < tex_coords3.z - 0.00005) ? true : false;
		bool b9 = (val9 < tex_coords3.z - 0.00005) ? true : false;
		pcf = (val1 + val2 + val3 + val4 + val5 + val6 + val7 + val8 + val9)/9;
		pcf = (b1 || b2 || b3 || b4 || b5 || b6 || b7 || b8 || b9) ? pcf : 1.0;
	}
	else if(tex_coords4.x >= 0.0 && tex_coords4.x <= 1.0 &&
	tex_coords4.y >= 0.0 && tex_coords4.y <= 1.0)
	{
		magenta = true;
	    inShadow = (depth4 < tex_coords4.z) ? true : false;
		float sum = 0.0;
		float val1 = textureProjOffset(shadowMap4,vec4(tex_coords4,1.0),ivec2(-1,-1)).r;
		float val2 = textureProjOffset(shadowMap4,vec4(tex_coords4,1.0),ivec2(-1,1)).r;
		float val3 = textureProjOffset(shadowMap4,vec4(tex_coords4,1.0),ivec2(1,-1)).r;
		float val4 = textureProjOffset(shadowMap4,vec4(tex_coords4,1.0),ivec2(1,1)).r;
		float val5 = textureProjOffset(shadowMap4,vec4(tex_coords4,1.0),ivec2(0,-1)).r;
		float val6 = textureProjOffset(shadowMap4,vec4(tex_coords4,1.0),ivec2(0,1)).r;
		float val7 = textureProjOffset(shadowMap4,vec4(tex_coords4,1.0),ivec2(-1,0)).r;
		float val8 = textureProjOffset(shadowMap4,vec4(tex_coords4,1.0),ivec2(1,0)).r;
		float val9 = textureProjOffset(shadowMap4,vec4(tex_coords4,1.0),ivec2(0,0)).r;
		bool b1 = (val1 < tex_coords4.z - 0.00005) ? true : false;
		bool b2 = (val2 < tex_coords4.z - 0.00005) ? true : false;
		bool b3 = (val3 < tex_coords4.z - 0.00005) ? true : false;
		bool b4 = (val4 < tex_coords4.z - 0.00005) ? true : false;
		bool b5 = (val5 < tex_coords4.z - 0.00005) ? true : false;
		bool b6 = (val6 < tex_coords4.z - 0.00005) ? true : false;
		bool b7 = (val7 < tex_coords4.z - 0.00005) ? true : false;
		bool b8 = (val8 < tex_coords4.z - 0.00005) ? true : false;
		bool b9 = (val9 < tex_coords4.z - 0.00005) ? true : false;
		pcf = (val1 + val2 + val3 + val4 + val5 + val6 + val7 + val8 + val9)/9;
		pcf = (b1 || b2 || b3 || b4 || b5 || b6 || b7 || b8 || b9) ? pcf : 1.0;
	}
	else if(tex_coords5.x >= 0.0 && tex_coords5.x <= 1.0 &&
	tex_coords5.y >= 0.0 && tex_coords5.y <= 1.0)
	{
	  inShadow = (depth5 < tex_coords5.z) ? true : false;
	//vec3 tex_coords5 = SM_tex_coord5.xyz/SM_tex_coord5.w;
	//depth1 = texture(shadowMap1, tex_coords1.xy).r; 
		yellow = true;

		float sum = 0.0;
		float val1 = textureProjOffset(shadowMap5,vec4(tex_coords5,1.0),ivec2(-1,-1)).r;
		float val2 = textureProjOffset(shadowMap5,vec4(tex_coords5,1.0),ivec2(-1,1)).r;
		float val3 = textureProjOffset(shadowMap5,vec4(tex_coords5,1.0),ivec2(1,-1)).r;
		float val4 = textureProjOffset(shadowMap5,vec4(tex_coords5,1.0),ivec2(1,1)).r;
		float val5 = textureProjOffset(shadowMap5,vec4(tex_coords5,1.0),ivec2(0,-1)).r;
		float val6 = textureProjOffset(shadowMap5,vec4(tex_coords5,1.0),ivec2(0,1)).r;
		float val7 = textureProjOffset(shadowMap5,vec4(tex_coords5,1.0),ivec2(-1,0)).r;
		float val8 = textureProjOffset(shadowMap5,vec4(tex_coords5,1.0),ivec2(1,0)).r;
		float val9 = textureProjOffset(shadowMap5,vec4(tex_coords5,1.0),ivec2(0,0)).r;
		bool b1 = (val1 < tex_coords5.z - 0.0005) ? true : false;
		bool b2 = (val2 < tex_coords5.z - 0.0005) ? true : false;
		bool b3 = (val3 < tex_coords5.z - 0.0005) ? true : false;
		bool b4 = (val4 < tex_coords5.z - 0.0005) ? true : false;
		bool b5 = (val5 < tex_coords5.z - 0.0005) ? true : false;
		bool b6 = (val6 < tex_coords5.z - 0.0005) ? true : false;
		bool b7 = (val7 < tex_coords5.z - 0.0005) ? true : false;
		bool b8 = (val8 < tex_coords5.z - 0.0005) ? true : false;
		bool b9 = (val9 < tex_coords5.z - 0.0005) ? true : false;
		pcf = (val1 + val2 + val3 + val4 + val5 + val6 + val7 + val8 + val9)/9;
		pcf = (b1 || b2 || b3 || b4 || b5 || b6 || b7 || b8 || b9) ? pcf : 1.0;

	}

	
		vec4 specular = vec4(1.0,0.6,0.6,1.0);
		float shininess = 100; //je hher desto kleiner die glanzpunkte
		vec4 ambient = amb;//vec4(0.6,0.4,0.4,1.0);
		vec4 diffuse = vec4(1.0,0.6,0.6,1.0);
        vec3 textureColor = texture(colorTexture, UV).rgb;
		//vec3 textureColorShadowMap = texture(textureShadowMap, UV).rgb;
		//fragColor = vec4(textureColor,1.0);
		 
		// normalize both input vectors
		vec3 n = normalize(n);
		vec3 e = normalize(vec3(eye));
		float intensity = max(dot(n,l_dir), 0.0);

		fragColor =  max(vec4(textureColor,1.0) * intensity *  diffuse, vec4(textureColor,1.0) *ambient) * pcf;
		
		if(inShadow == true)
		{
		   //fragColor = fragColor * 0.5;
		}

		if(showCascadesFrag == 1)
		{
			if(red)
			{
				fragColor = fragColor + vec4(0.2,0.0,0.0,0.0);
			}
			else if(green)
			{
				fragColor = fragColor + vec4(0.0,0.2,0.0,0.0);
			}
			else if(blue)
			{
				fragColor = fragColor + vec4(0.0,0.0,0.2,0.0);
			}
			else if(magenta)
			{
				fragColor = fragColor + vec4(0.2,0.0,0.2,0.0);
			}
			else if(yellow)
			{
				fragColor = fragColor + vec4(0.2,0.2,0.0,0.0);
			}
		}

}

