#version 330

in vec3 n;
in vec4 eye;
in vec3 l_dir;
out vec4 fragColor;

void main()
{

		vec4 specular = vec4(1.0,1.0,1.0,1.0);
		float shininess = 100; //je hher desto kleiner die glanzpunkte
		vec4 ambient = vec4(0.7,0.7,0.7,1.0);
		vec4 diffuse = vec4(1.0,1.0,1.0,1.0);
        vec3 color = vec3(0.5,0.5,0.5);
		//fragColor = vec4(textureColor,1.0);

		// set the specular term to black
		vec4 spec = vec4(0.0);
 
		// normalize both input vectors
		vec3 n = normalize(n);
		vec3 e = normalize(vec3(eye));
		float intensity = max(dot(n,l_dir), 0.0);
		// if the vertex is lit compute the specular color
		if (intensity > 0.0) {
			// compute the half vector
			vec3 h = normalize(l_dir + e);  
			// compute the specular term into spec
			float intSpec = max(dot(h,n), 0.0);
			spec = specular * pow(intSpec,shininess);
		}
		fragColor =  max(vec4(color,1.0) * intensity *  diffuse + spec, vec4(color,1.0) *ambient);

}