#version 330
//uniform mat4 MVP;
 // Notice that the "1" here equals the "1" in glVertexAttribPointer
// Input vertex data, different for all executions of this shader.
layout(location = 0) in vec3 vertexPosition_modelspace;
layout(location = 2) in vec3 normal;
// Output data ; will be interpolated for each fragment.
uniform mat4 modelMatrix;
uniform mat4 projectionMatrix;
uniform mat4 viewMatrix;
out vec3 n;
out vec4 eye;
out vec3 l_dir;
void main(){
 
   
    vec4 v = vec4(vertexPosition_modelspace,1); // Transform an homogeneous 4D vector, remember ?
    gl_Position =   projectionMatrix  * viewMatrix * modelMatrix * vec4(vertexPosition_modelspace, 1);

	mat4 m_normal = transpose(inverse(viewMatrix * modelMatrix));
	n = normalize(mat3(m_normal) * normal);
	eye = -(modelMatrix * viewMatrix * vec4(vertexPosition_modelspace,1.0));
	l_dir = mat3(viewMatrix) * vec3(1.0,1.0,1.0);
	
}