#version 330

in vec2 UV;
in vec3 n;
in vec4 eye;
in vec3 l_dir;
in vec4 amb;
out vec4 fragColor;
in vec4 SM_tex_coord1;
in vec4 SM_tex_coord2;
in vec4 SM_tex_coord3;
in vec4 SM_tex_coord4;
in vec4 SM_tex_coord5;
in vec4 worldPos;
in vec4 worldCharPos;
flat in int showCascadesFrag;
uniform sampler2D colorTexture;
uniform sampler2D shadowMap1;
uniform sampler2D shadowMap2;
uniform sampler2D shadowMap3;
uniform sampler2D shadowMap4;
uniform sampler2D shadowMap5;


void main()
{

	
		vec4 specular = vec4(1.0,0.6,0.6,1.0);
		float shininess = 100; //je hher desto kleiner die glanzpunkte
		vec4 ambient = amb;//vec4(0.6,0.4,0.4,1.0);
		vec4 diffuse = vec4(1.0,0.6,0.6,1.0);
        vec3 textureColor = texture(colorTexture, UV).rgb;

		vec4 spec = vec4(0.0);
 
		// normalize both input vectors
		vec3 n = normalize(n);
		vec3 e = normalize(vec3(eye));
		float intensity = max(dot(n,l_dir), 0.0);
		// if the vertex is lit compute the specular color
		if (intensity > 0.0) {
			// compute the half vector
			vec3 h = normalize(l_dir + e);  
			// compute the specular term into spec
			float intSpec = max(dot(h,n), 0.0);
			spec = specular * pow(intSpec,shininess);
		}


		fragColor =  max(vec4(textureColor,1.0) * intensity *  diffuse + spec, vec4(textureColor,1.0) *ambient);
		



		fragColor = vec4(fragColor.r,fragColor.g,fragColor.b,0.3);

}

